#include "libgraph.h"
#include <alloc.h>


value gr_set_clip_area(vx, vy, vw, vh)	/* ML */
      value vx, vy, vw, vh;
{
  int x, y, w, h;
  XRectangle rect;
  Region region;

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_set_clip: Validwin=%d; x,y,w,h=%d,%d\n", 
           ValidWindow, Int_val(vx), Int_val(vy), Int_val(vw), Int_val(vy));
#endif 

  if(ValidWindow==FALSE) return Val_unit;
  
  x = Int_val(vx);
  y = Int_val(vy);
  w = Int_val(vw);
  if(w>grwindows[current_window].w) w=grwindows[current_window].w;
  h = Int_val(vh);
  if(h>grwindows[current_window].h) h=grwindows[current_window].h;

  rect.x=x;
  if(rect.x<0) rect.x=0;

  rect.y=Wcvt(y) - h + 1;
  if(rect.y<0) rect.y=0;

  rect.width=w+1;
  rect.height=h;

  XSetClipMask(grdisplay,grwindows[current_window].gc,None);
  XSetClipRectangles(grdisplay,grwindows[current_window].gc,
                     0,0,&rect,1,Unsorted);

#ifdef DEBUG_DRAW 
   fprintf(stderr,"gr_set_clip: end\n");
#endif 
  return Val_unit;
}
